## zmqpp 3.2.0

=== Makefile ===
#
# Instance values, command line user specifiable
#

CONFIG   = max
CPPFLAGS = 
CXXFLAGS = 
LDFLAGS  = 

PREFIX = /usr/local
BINDIR = $(DESTDIR)$(PREFIX)/bin
LIBDIR = $(DESTDIR)$(PREFIX)/lib
INCLUDEDIR = $(DESTDIR)$(PREFIX)/include

#
# Tools
#

CXX      = g++
LD       = $(CXX)
AR       = ar

#
# Build values
#

LIBRARY_NAME     = zmqpp
VERSION_MAJOR    = 3
VERSION_MINOR    = 2
VERSION_REVISION = 0

#
# Paths
#

LIBRARY_DIR  = $(LIBRARY_NAME)
CLIENT_DIR   = client
TESTS_DIR    = tests

SRC_PATH     = ./src
LIBRARY_PATH = $(SRC_PATH)/$(LIBRARY_DIR)
CLIENT_PATH  = $(SRC_PATH)/$(CLIENT_DIR)
TESTS_PATH   = $(SRC_PATH)/$(TESTS_DIR)

BUILD_PATH   = ./build/$(CONFIG)-$(CXX)
OBJECT_PATH  = $(BUILD_PATH)/obj

#
# Core values
#

APP_VERSION    = $(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_REVISION)
APP_DATESTAMP  = $(shell date '+"%Y-%m-%d %H:%M"')

LIBRARY_SHARED  = lib$(LIBRARY_NAME).so
LIBRARY_ARCHIVE = lib$(LIBRARY_NAME).a
CLIENT_TARGET   = $(LIBRARY_NAME)
TESTS_TARGET    = $(LIBRARY_NAME)-tests

CONFIG_FLAGS =
ifeq ($(CONFIG),debug)
	CONFIG_FLAGS = -g -fno-inline -ftemplate-depth-1000
endif
ifeq ($(CONFIG),valgrind)
	CONFIG_FLAGS = -g -O1 -DNO_DEBUG_LOG -DNO_TRACE_LOG
endif
ifeq ($(CONFIG),max)
	CONFIG_FLAGS = -O3 -funroll-loops -ffast-math -finline-functions -fomit-frame-pointer -DNDEBUG
endif
ifneq (,$(findstring $(CONFIG),release loadtest))
	CONFIG_FLAGS = -O3 -funroll-loops -ffast-math -finline-functions -fomit-frame-pointer -DNO_DEBUG_LOG -DNO_TRACE_LOG -DNDEBUG
endif

COMMON_FLAGS = -MMD -std=c++0x -pipe -Wall -fPIC \
	-DBUILD_ENV=$(CONFIG) \
	-DBUILD_VERSION='"$(APP_VERSION)"' \
	-DBUILD_VERSION_MAJOR=$(VERSION_MAJOR) \
	-DBUILD_VERSION_MINOR=$(VERSION_MINOR) \
	-DBUILD_VERSION_REVISION=$(VERSION_REVISION) \
	-DBUILD_DATESTAMP='$(APP_DATESTAMP)' \
	-DBUILD_LIBRARY_NAME='"$(LIBRARY_NAME)"' \
	-DBUILD_CLIENT_NAME='"$(CLIENT_TARGET)"' \
	-I$(SRC_PATH)

COMMON_LIBS = -lzmq

LIBRARY_LIBS =  

CLIENT_LIBS = -L$(BUILD_PATH) \
	-l$(LIBRARY_NAME) \
	-lboost_program_options

TEST_LIBS = -L$(BUILD_PATH) \
	-l$(LIBRARY_NAME) \
	-lboost_unit_test_framework

ifeq ($(CONFIG),loadtest)
	CONFIG_FLAGS := $(CONFIG_FLAGS) -DLOADTEST
	TEST_LIBS := $(TEST_LIBS) -lboost_thread -lboost_system
endif

ALL_LIBRARY_OBJECTS := $(patsubst $(SRC_PATH)/%.cpp, $(OBJECT_PATH)/%.o, $(shell find $(LIBRARY_PATH) -iname '*.cpp'))

ALL_LIBRARY_INCLUDES := $(shell find $(LIBRARY_PATH) -iname '*.hpp')

ALL_CLIENT_OBJECTS := $(patsubst $(SRC_PATH)/%.cpp, $(OBJECT_PATH)/%.o, $(shell find $(CLIENT_PATH) -iname '*.cpp'))

ALL_TEST_OBJECTS := $(patsubst $(SRC_PATH)/%.cpp, $(OBJECT_PATH)/%.o, $(shell find $(TESTS_PATH) -iname '*.cpp'))

TEST_SUITES := ${addprefix test-,${sort ${shell find ${TESTS_PATH} -iname *.cpp | xargs grep BOOST_AUTO_TEST_SUITE\( | sed 's/.*BOOST_AUTO_TEST_SUITE( \(.*\) )/\1/' }}}

#
# BUILD Targets - Standardised
#

.PHONY: clean uninstall test $(TEST_SUITES)

main: $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE)
	@echo "use make check to test the build"

all: $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(CLIENT_TARGET)
	@echo "use make check to test the build"

check: $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) test

install:
	install -m 644 $(ALL_LIBRARY_INCLUDES) $(INCLUDEDIR)/$(LIBRARY_DIR)
	install -m 755 $(BUILD_PATH)/$(LIBRARY_SHARED).$(VERSION_MAJOR) $(LIBDIR)/$(LIBRARY_SHARED).$(APP_VERSION)
	ln -sf $(LIBRARY_SHARED).$(APP_VERSION) $(LIBDIR)/$(LIBRARY_SHARED).$(VERSION_MAJOR)
	ln -sf $(LIBRARY_SHARED).$(APP_VERSION) $(LIBDIR)/$(LIBRARY_SHARED)
	if [ -f $(BUILD_PATH)/$(CLIENT_TARGET) ]; then install -m 755 $(BUILD_PATH)/$(CLIENT_TARGET) $(BINDIR); fi
	$(LDCONFIG)
	@echo "use make installcheck to test the install"
	
installcheck: $(TESTS_TARGET)
	$(BUILD_PATH)/$(TESTS_TARGET)

uninstall:
	rm -rf $(INCLUDEDIR)/$(LIBRARY_DIR)
	rm -f $(LIBDIR)/$(LIBRARY_SHARED).$(APP_VERSION)
	rm -f $(LIBDIR)/$(LIBRARY_SHARED).$(VERSION_MAJOR)
	rm -f $(LIBDIR)/$(LIBRARY_SHARED)
	rm -f $(BINDIR)/$(CLIENT_TARGET)

clean:
	rm -rf $(BUILD_PATH)
	rm -rf docs

client: $(CLIENT_TARGET)

library: $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE)

#
# BUILD Targets
#

$(LIBRARY_SHARED): $(ALL_LIBRARY_OBJECTS)
	$(LD) $(LDFLAGS) -shared -rdynamic -Wl,-soname -Wl,$(LIBRARY_SHARED).$(VERSION_MAJOR) -o $(BUILD_PATH)/$@.$(VERSION_MAJOR) $^ $(LIBRARY_LIBS) $(COMMON_LIBS)

$(LIBRARY_ARCHIVE): $(ALL_LIBRARY_OBJECTS)
	$(AR) crf $(BUILD_PATH)/$@ $^

$(CLIENT_TARGET): $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(ALL_CLIENT_OBJECTS)
	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_CLIENT_OBJECTS) $(CLIENT_LIBS) $(COMMON_LIBS)

$(TESTS_TARGET): $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(ALL_TEST_OBJECTS)
	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_TEST_OBJECTS) $(TEST_LIBS) $(COMMON_LIBS) 

$(TEST_SUITES): $(TESTS_TARGET)
	LD_LIBRARY_PATH=$(BUILD_PATH):$(LD_LIBRARY_PATH) $(BUILD_PATH)/$(TESTS_TARGET) --log_level=message --run_test=$(patsubst test-%,%,$@)

test: $(TESTS_TARGET)
	@echo "running all test targets ($(TEST_SUITES))"
	LD_LIBRARY_PATH=$(BUILD_PATH):$(LD_LIBRARY_PATH) $(BUILD_PATH)/$(TESTS_TARGET)

#
# Dependencies
# We don't care if they don't exist as the object won't have been built
#

-include $(patsubst %.o,%.d,$(ALL_LIBRARY_OBJECTS) $(ALL_TEST_OBJECTS))

#
# Object file generation
#

$(OBJECT_PATH)/%.o: $(SRC_PATH)/%.cpp
	-mkdir -p $(dir $@)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) $(COMMON_FLAGS) $(CONFIG_FLAGS) -c -o $@ $<

=== debian/changelog ===
zmqpp (3.2.0-0ubuntu4) xenial; urgency=medium

  * (Build-)depend on libzmq5-dev.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Mar 2016 19:08:23 +0100

zmqpp (3.2.0-0ubuntu4~gcc5.1) wily; urgency=medium

  * No-change test rebuild for g++5 ABI transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 15 Jul 2015 16:30:02 +0000

zmqpp (3.2.0-0ubuntu3) trusty; urgency=low

  * debian/rules:
    - Force -g to allow generating -dbg packages
  * debian/patches/fix_1256886.diff:
    - Fix memory alignment crash issue (LP: #1256886)

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Mon, 02 Dec 2013 14:16:41 +0100

zmqpp (3.2.0-0ubuntu2) trusty; urgency=low

  * debian/control:
    - Add the missing libzmq3-dev dependency to the libzmqpp-dev package
    - Fixed missing dependency on the main library
  * debian/changelog:
    - Use the correct GPL-3 license text for packaging

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Fri, 15 Nov 2013 18:22:31 +0100

zmqpp (3.2.0-0ubuntu1) trusty; urgency=low

  * Initial release

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Tue, 12 Nov 2013 17:25:07 +0100

=== debian/control ===
Source: zmqpp
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>
Build-Depends: debhelper (>= 9),
               automake,
               libboost-test-dev,
               libzmq5-dev | libzmq-dev,
Standards-Version: 3.9.4
Homepage: https://github.com/benjamg/zmqpp
Vcs-Bzr: lp:zmqpp/ubuntu

Package: libzmqpp3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: High-level C++ bindings for zeromq3
 This C++ binding is a 'high-level' library that hides most of the c-style
 interface core 0mq provides.

Package: libzmqpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libzmqpp3 (= ${binary:Version}),
         libzmq5-dev,
Description: High-level C++ bindings for zeromq3 - development files
 This C++ binding is a 'high-level' library that hides most of the c-style
 interface core 0mq provides.
 This package provides development files and headers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --fail-missing

override_dh_auto_build:
	dh_auto_build -- CXXFLAGS+=-g

override_dh_auto_install:
	dh_auto_install -- PREFIX="/usr" LIBDIR="debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)"

=== debian/watch ===
version=3


opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/zmqpp-$1.tar.gz/ \
   https://github.com/benjamg/zmqpp/tags .*/v?(\d\S*)\.tar\.gz

## zmqpp 4.1.2

=== CMakeLists.txt ===
# ZMQPP Cmake build description.
# ==============================
#
# CMake should find the zmq libraries / headers automatically if they are
# installed system-wide. If CMake cannot find them not, or you would like to
# use custom built ones, set these variables:
#
#   - ZEROMQ_LIB_DIR to the directory where libzmq / libzmq-shared is located
#
#   - ZEROMQ_INCLUDE_DIR to the directory where zmq.h is located
#


cmake_minimum_required(VERSION 2.8)
enable_testing()

# prepare C++11
set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")

# show all warnings
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -Wextra")

# Set a consistent MACOSX_RPATH default across all CMake versions.  When CMake
# 2.8.12 is required, change this default to 1.  When CMake 3.0.0 is required,
# remove this block (see CMP0042).
#
# TODO: verify correctness of this flag
if(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH 0)
endif()

# If libzmq is build in the same cmake global project and we want to
# depends on it instead of searching for libzmq in the system, we set this to true
set( ZMQPP_LIBZMQ_CMAKE   false   CACHE BOOL "libzmq is build through cmake too" )


set( ZMQPP_BUILD_STATIC   true   CACHE BOOL "Build the ZMQPP static library" )
set( ZMQPP_BUILD_SHARED   true   CACHE BOOL "Build the ZMQPP dynamic library" )

set( ZMQPP_BUILD_EXAMPLES false   CACHE BOOL "Build the ZMQPP examples" )
set( ZMQPP_BUILD_CLIENT   false   CACHE BOOL "Build the ZMQPP client" )
set( ZMQPP_BUILD_TESTS    false   CACHE BOOL "Build the ZMQPP tests" )


# Since the current CMake build of ZMQ does not work for generating a dynamic libzmq,
# give a chance for users to update which ZMQ library to link to

# zmq-static is the name of the static target in libzmq's CMakeLists.txt
set( ZMQPP_LIBZMQ_NAME_STATIC  "zmq-static" CACHE STRING "The ZMQ library to link the static ZMQPP. (if built)" )
set( ZMQPP_LIBZMQ_NAME_SHARED  "zmq"        CACHE STRING "The ZMQ library to link the dynamic ZMQPP. (if built)" )

# Paths to set to look for zmq
set( ZEROMQ_LIB_DIR       ""      CACHE PATH "The library directory for libzmq" )
set( ZEROMQ_INCLUDE_DIR   ""      CACHE PATH "The include directory for ZMQ" )

# Build flags
set( IS_TRAVIS_CI_BUILD   true    CACHE bool "Defines TRAVIS_CI_BUILD - Should the tests avoid running cases where memory is scarce." )

# Find zmq.h and add its dir to the includes
find_path(ZEROMQ_INCLUDE zmq.h PATHS ${ZEROMQ_INCLUDE_DIR})
include_directories(${ZEROMQ_INCLUDE_DIR} ${ZEROMQ_INCLUDE} ${CMAKE_CURRENT_SOURCE_DIR}/src )

# Do not run some tests when building on travis-ci (this cause oom error and kill the test
# process)
# These tests seem to be:
#    - sending_large_messages_string
if (IS_TRAVIS_CI_BUILD)
  add_definitions( -DTRAVIS_CI_BUILD)
endif()

set( INSTALL_TARGET_LIST )

# The library to link with the examples and the tests.
# Because we may or may not build shared/static libs, this needs to
# be dynamic
set( LIB_TO_LINK_TO_EXAMPLES )


# libzmqpp
# --------

set( LIBZMQPP_SOURCES
  src/zmqpp/actor.cpp
  src/zmqpp/context.cpp
  src/zmqpp/curve.cpp
  src/zmqpp/frame.cpp
  src/zmqpp/message.cpp
  src/zmqpp/poller.cpp
  src/zmqpp/reactor.cpp
  src/zmqpp/signal.cpp
  src/zmqpp/socket.cpp
  src/zmqpp/z85.cpp
  src/zmqpp/zap_request.cpp
  src/zmqpp/auth.cpp
  src/zmqpp/zmqpp.cpp
  )

# Staticlib
if (ZMQPP_BUILD_STATIC)
  add_library( zmqpp-static STATIC ${LIBZMQPP_SOURCES})
  if (NOT ZMQPP_LIBZMQ_CMAKE)
    find_library(ZEROMQ_LIBRARY_STATIC ${ZMQPP_LIBZMQ_NAME_STATIC} PATHS ${ZEROMQ_LIB_DIR})
    if (NOT ZEROMQ_LIBRARY_STATIC)
      # If libzmq was not installed through CMake, the static binary is libzmq.a not libzmq-static.a
      find_library(ZEROMQ_LIBRARY_STATIC libzmq.a PATHS ${ZEROMQ_LIB_DIR})
    endif()
    target_link_libraries( zmqpp-static ${ZEROMQ_LIBRARY_STATIC})
  else()
    # libzmq-static is the name of the target from
    # libzmq's CMake
    target_link_libraries(zmqpp-static libzmq-static)
  endif()
  list( APPEND INSTALL_TARGET_LIST zmqpp-static)
  set( LIB_TO_LINK_TO_EXAMPLES zmqpp-static )
endif() # ZMQPP_BUILD_STATIC

# Shared lib
if (ZMQPP_BUILD_SHARED)
  add_library( zmqpp SHARED ${LIBZMQPP_SOURCES})
  if (NOT ZMQPP_LIBZMQ_CMAKE)
    find_library(ZEROMQ_LIBRARY_SHARED ${ZMQPP_LIBZMQ_NAME_SHARED} PATHS ${ZEROMQ_LIB_DIR})
    target_link_libraries( zmqpp ${ZEROMQ_LIBRARY_SHARED} )
  else()
    # libzmq is the name of the target from
    # libzmq's CMake
    target_link_libraries(zmqpp libzmq)
  endif()
  list( APPEND INSTALL_TARGET_LIST zmqpp)
  set( LIB_TO_LINK_TO_EXAMPLES zmqpp )
endif() # ZMQPP_BUILD_SHARED

# Examples
# --------

if(ZMQPP_BUILD_EXAMPLES)
  add_executable( zmqpp-simple-server
    examples/simple_server
    )

  add_executable( zmqpp-simple-client
    examples/simple_client
    )

  target_link_libraries( zmqpp-simple-client ${LIB_TO_LINK_TO_EXAMPLES} )
  target_link_libraries( zmqpp-simple-server ${LIB_TO_LINK_TO_EXAMPLES} )
  list( APPEND INSTALL_TARGET_LIST zmqpp-simple-server zmqpp-simple-client )
endif()



# Client
# ------

if( ZMQPP_BUILD_CLIENT )
  # Boost
  # -----
  set(Boost_USE_STATIC_LIBS ON)
  set(Boost_USE_MULTITHREADED ON)
  set(Boost_USE_STATIC_RUNTIME OFF)
  find_package(Boost REQUIRED COMPONENTS program_options )
  include_directories( ${Boost_INCLUDE_DIRS} )

  add_executable( zmqpp-client
    src/client/main.cpp
    src/client/options.cpp
    )
  target_link_libraries( zmqpp-client ${LIB_TO_LINK_TO_EXAMPLES} ${Boost_LIBRARIES} )
  list( APPEND INSTALL_TARGET_LIST zmqpp-client )
endif()

# Tests
# -----

if( ZMQPP_BUILD_TESTS )
  #
  # Boost
  # -----
  set(Boost_USE_STATIC_LIBS OFF) # only find static libs
  set(Boost_USE_MULTITHREADED ON)
  set(Boost_USE_STATIC_RUNTIME OFF)
  find_package(Boost REQUIRED COMPONENTS thread system unit_test_framework)
  include_directories( ${Boost_INCLUDE_DIRS} )

  add_executable( zmqpp-test-runner
    src/tests/test_actor.cpp
    src/tests/test_context.cpp
    src/tests/test_inet.cpp
    src/tests/test_load.cpp
    src/tests/test_message.cpp
    src/tests/test_message_stream.cpp
    src/tests/test_poller.cpp
    src/tests/test_reactor.cpp
    src/tests/test_sanity.cpp
    src/tests/test_socket.cpp
    src/tests/test_socket_options.cpp
    src/tests/test_z85.cpp
    src/tests/test_auth.cpp
    )
  target_link_libraries( zmqpp-test-runner  ${LIB_TO_LINK_TO_EXAMPLES} ${Boost_LIBRARIES})
  add_test( zmqpp-test zmqpp-test-runner --log-level=test-suite )
endif()


# Install
# -------
install(TARGETS ${INSTALL_TARGET_LIST}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

install(DIRECTORY src/zmqpp DESTINATION include/
        FILES_MATCHING PATTERN "*.hpp")

=== Makefile ===
--- 
+++ 
@@ -3,9 +3,9 @@
 #
 
 CONFIG   = max
-CPPFLAGS = 
-CXXFLAGS = 
-LDFLAGS  = 
+CPPFLAGS =
+CXXFLAGS =
+LDFLAGS  =
 
 PREFIX = /usr/local
 BINDIR = $(DESTDIR)$(PREFIX)/bin
@@ -16,7 +16,7 @@
 # Tools
 #
 
-CXX      = g++
+#CXX      = g++
 LD       = $(CXX)
 AR       = ar
 
@@ -25,9 +25,9 @@
 #
 
 LIBRARY_NAME     = zmqpp
-VERSION_MAJOR    = 3
-VERSION_MINOR    = 2
-VERSION_REVISION = 0
+VERSION_MAJOR    = 4
+VERSION_MINOR    = 1
+VERSION_REVISION = 2
 
 #
 # Paths
@@ -45,6 +45,8 @@
 BUILD_PATH   = ./build/$(CONFIG)-$(CXX)
 OBJECT_PATH  = $(BUILD_PATH)/obj
 
+CUSTOM_INCLUDE_PATH =
+
 #
 # Core values
 #
@@ -53,10 +55,30 @@
 APP_DATESTAMP  = $(shell date '+"%Y-%m-%d %H:%M"')
 
 LIBRARY_SHARED  = lib$(LIBRARY_NAME).so
+LIBRARY_VERSION_SHARED = $(LIBRARY_SHARED).$(VERSION_MAJOR)
+LIBRARY_FULL_VERSION_SHARED = $(LIBRARY_SHARED).$(APP_VERSION)
 LIBRARY_ARCHIVE = lib$(LIBRARY_NAME).a
 CLIENT_TARGET   = $(LIBRARY_NAME)
 TESTS_TARGET    = $(LIBRARY_NAME)-tests
 
+
+# OS Specific values
+
+UNAME_S := $(shell uname -s)
+LD_EXTRA =
+AR_EXTRA = 
+ifeq ($(UNAME_S),Linux)
+	LD_EXTRA += -Wl,-soname -Wl,$(LIBRARY_VERSION_SHARED)
+	AR_EXTRA = crf
+endif
+ifeq ($(UNAME_S),Darwin)
+	LIBRARY_SHARED = lib$(LIBRARY_NAME).dylib
+	LIBRARY_VERSION_SHARED = lib$(LIBRARY_NAME).$(VERSION_MAJOR).dylib
+	LIBRARY_FULL_VERSION_SHARED = lib$(LIBRARY_NAME).$(APP_VERSION).dylib
+	AR_EXTRA = cr
+endif
+
+
 CONFIG_FLAGS =
 ifeq ($(CONFIG),debug)
 	CONFIG_FLAGS = -g -fno-inline -ftemplate-depth-1000
@@ -71,20 +93,16 @@
 	CONFIG_FLAGS = -O3 -funroll-loops -ffast-math -finline-functions -fomit-frame-pointer -DNO_DEBUG_LOG -DNO_TRACE_LOG -DNDEBUG
 endif
 
-COMMON_FLAGS = -MMD -std=c++0x -pipe -Wall -fPIC \
+COMMON_FLAGS = -MMD -std=c++11 -pipe -Wall -fPIC \
 	-DBUILD_ENV=$(CONFIG) \
-	-DBUILD_VERSION='"$(APP_VERSION)"' \
-	-DBUILD_VERSION_MAJOR=$(VERSION_MAJOR) \
-	-DBUILD_VERSION_MINOR=$(VERSION_MINOR) \
-	-DBUILD_VERSION_REVISION=$(VERSION_REVISION) \
 	-DBUILD_DATESTAMP='$(APP_DATESTAMP)' \
 	-DBUILD_LIBRARY_NAME='"$(LIBRARY_NAME)"' \
 	-DBUILD_CLIENT_NAME='"$(CLIENT_TARGET)"' \
-	-I$(SRC_PATH)
+	-I$(SRC_PATH) $(CUSTOM_INCLUDE_PATH)
 
 COMMON_LIBS = -lzmq
 
-LIBRARY_LIBS =  
+LIBRARY_LIBS =
 
 CLIENT_LIBS = -L$(BUILD_PATH) \
 	-l$(LIBRARY_NAME) \
@@ -92,7 +110,9 @@
 
 TEST_LIBS = -L$(BUILD_PATH) \
 	-l$(LIBRARY_NAME) \
-	-lboost_unit_test_framework
+	-lsodium \
+	-lboost_unit_test_framework \
+	-lpthread
 
 ifeq ($(CONFIG),loadtest)
 	CONFIG_FLAGS := $(CONFIG_FLAGS) -DLOADTEST
@@ -124,26 +144,30 @@
 check: $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) test
 
 install:
+	mkdir -p $(INCLUDEDIR)/$(LIBRARY_DIR)
+	mkdir -p $(LIBDIR)
 	install -m 644 $(ALL_LIBRARY_INCLUDES) $(INCLUDEDIR)/$(LIBRARY_DIR)
-	install -m 755 $(BUILD_PATH)/$(LIBRARY_SHARED).$(VERSION_MAJOR) $(LIBDIR)/$(LIBRARY_SHARED).$(APP_VERSION)
-	ln -sf $(LIBRARY_SHARED).$(APP_VERSION) $(LIBDIR)/$(LIBRARY_SHARED).$(VERSION_MAJOR)
-	ln -sf $(LIBRARY_SHARED).$(APP_VERSION) $(LIBDIR)/$(LIBRARY_SHARED)
+	install -m 755 $(BUILD_PATH)/$(LIBRARY_VERSION_SHARED) $(LIBDIR)/$(LIBRARY_FULL_VERSION_SHARED)
+	install -m 755 $(BUILD_PATH)/$(LIBRARY_ARCHIVE) $(LIBDIR)/$(LIBRARY_ARCHIVE)
+	ln -sf $(LIBRARY_FULL_VERSION_SHARED) $(LIBDIR)/$(LIBRARY_VERSION_SHARED)
+	ln -sf $(LIBRARY_FULL_VERSION_SHARED) $(LIBDIR)/$(LIBRARY_SHARED)
 	if [ -f $(BUILD_PATH)/$(CLIENT_TARGET) ]; then install -m 755 $(BUILD_PATH)/$(CLIENT_TARGET) $(BINDIR); fi
 	$(LDCONFIG)
 	@echo "use make installcheck to test the install"
-	
+
 installcheck: $(TESTS_TARGET)
 	$(BUILD_PATH)/$(TESTS_TARGET)
 
 uninstall:
 	rm -rf $(INCLUDEDIR)/$(LIBRARY_DIR)
-	rm -f $(LIBDIR)/$(LIBRARY_SHARED).$(APP_VERSION)
-	rm -f $(LIBDIR)/$(LIBRARY_SHARED).$(VERSION_MAJOR)
+	rm -f $(LIBDIR)/$(LIBRARY_FULL_VERSION_SHARED)
+	rm -f $(LIBDIR)/$(LIBRARY_VERSION_SHARED)
 	rm -f $(LIBDIR)/$(LIBRARY_SHARED)
+	rm -f $(LIBDIR)/$(LIBRARY_ARCHIVE)
 	rm -f $(BINDIR)/$(CLIENT_TARGET)
 
 clean:
-	rm -rf $(BUILD_PATH)
+	rm -rf build/*
 	rm -rf docs
 
 client: $(CLIENT_TARGET)
@@ -155,16 +179,16 @@
 #
 
 $(LIBRARY_SHARED): $(ALL_LIBRARY_OBJECTS)
-	$(LD) $(LDFLAGS) -shared -rdynamic -Wl,-soname -Wl,$(LIBRARY_SHARED).$(VERSION_MAJOR) -o $(BUILD_PATH)/$@.$(VERSION_MAJOR) $^ $(LIBRARY_LIBS) $(COMMON_LIBS)
+	$(LD) $(LDFLAGS) -shared -rdynamic $(LD_EXTRA) -o $(BUILD_PATH)/$(LIBRARY_VERSION_SHARED) $^ $(LIBRARY_LIBS) $(COMMON_LIBS)
 
 $(LIBRARY_ARCHIVE): $(ALL_LIBRARY_OBJECTS)
-	$(AR) crf $(BUILD_PATH)/$@ $^
+	$(AR) $(AR_EXTRA) $(BUILD_PATH)/$@ $^
 
 $(CLIENT_TARGET): $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(ALL_CLIENT_OBJECTS)
 	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_CLIENT_OBJECTS) $(CLIENT_LIBS) $(COMMON_LIBS)
 
 $(TESTS_TARGET): $(LIBRARY_SHARED) $(LIBRARY_ARCHIVE) $(ALL_TEST_OBJECTS)
-	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_TEST_OBJECTS) $(TEST_LIBS) $(COMMON_LIBS) 
+	$(LD) $(LDFLAGS) -o $(BUILD_PATH)/$@ $(ALL_TEST_OBJECTS) $(TEST_LIBS) $(COMMON_LIBS)
 
 $(TEST_SUITES): $(TESTS_TARGET)
 	LD_LIBRARY_PATH=$(BUILD_PATH):$(LD_LIBRARY_PATH) $(BUILD_PATH)/$(TESTS_TARGET) --log_level=message --run_test=$(patsubst test-%,%,$@)

=== examples/Makefile ===
CPP			    = g++
RM			    = rm -f
CPPFLAGS		= -Wall -I. -O2 -std=c++11 -g
LDFLAGS			= -lpthread -lzmqpp -lzmq -lsodium -Wl,--no-as-needed
SOURCES			= $(wildcard *.cpp)
TARGETS			= $(SOURCES:%.cpp=%)

all:	${TARGETS}

clean:
	${RM} *.obj *~* ${TARGETS}

${TARGETS}:
	${CPP} ${CPPFLAGS} -o $@ ${@:%=%.cpp} ${LDFLAGS}

=== debian/changelog ===
zmqpp (4.1.2-0ubuntu2) artful; urgency=medium

  * debian/control:
    - Switch libzmqpp-dev to depend on libzmq3-dev instead of libzmq5-dev as
      the former is actually what the new zeromq provides
  * Cleaned up the unused mkdir_before_install.diff patch

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 22 Jun 2017 09:45:38 +0200

zmqpp (4.1.2-0ubuntu1) yakkety; urgency=medium

  * New upstream release
  * debian/copyright:
    - Follow up on the license change to MPLv2
  * debian/watch:
    - Point to the new upstream location
  * debian/patches/support_use_fd_option.diff:
    - Support for ZMQ_USE_FD (LP: #1612240)
  * debian/patches/fix_ftbfs_new_boost.diff:
    - Fix FTBFS on yakkety due to boost1.61
  * debian/control:
    - Bump the libzmq3-dev dependency for the new required features in zeromq
    - Add the libsodium-dev build-dep for the test libs
    - Rename package to libzmqpp4 as the ABI changed and the soname was bumped
    - Bump the standards version to 3.9.7
  * debian/rules:
    - Remove the unneeded statically linked library archive
  * Drop debian/patches/mkdir_before_install.diff
  * Drop debian/patches/fix_1256886.diff

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 11 Aug 2016 17:15:27 +0200

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
 Build-Depends: debhelper (>= 9),
                automake,
                libboost-test-dev,
-               libzmq5-dev | libzmq-dev,
-Standards-Version: 3.9.4
-Homepage: https://github.com/benjamg/zmqpp
+               libzmq3-dev (>= 4.1.5+git20160811+2fc86bc),
+               libsodium-dev,
+Standards-Version: 3.9.7
+Homepage: https://github.com/zeromq/zmqpp
 Vcs-Bzr: lp:zmqpp/ubuntu
 
-Package: libzmqpp3
+Package: libzmqpp4
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -28,8 +29,8 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libzmqpp3 (= ${binary:Version}),
-         libzmq5-dev,
+         libzmqpp4 (= ${binary:Version}),
+         libzmq3-dev,
 Description: High-level C++ bindings for zeromq3 - development files
  This C++ binding is a 'high-level' library that hides most of the c-style
  interface core 0mq provides.

=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,5 @@
 
 override_dh_auto_install:
 	dh_auto_install -- PREFIX="/usr" LIBDIR="debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)"
+	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libzmqpp.a

=== debian/watch ===
version=3


opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/zmqpp-$1.tar.gz/ \
   https://github.com/zeromq/zmqpp/tags .*/v?(\d\S*)\.tar\.gz
